
/*
Music Toy; James Bensley;
Dont ask me for help if you can't get it working, I still don't know what I'm doing

*/

// Includes And Headers:
#include "LiquidCrystal.h"  // library for the liquid crystal display (on a 4bit bus I think!)

// Digital Pins:
const int intPinButM = 10;
const int intPinButA = 9;
const int intPinButB = 8;
const int intPinSpk = 6;

// Global Variables:
int aryTones[] = {0, 31, 33, 35, 37, 39, 41, 44, 46, 49, 52, 55, 58, 62, 65, 69, 73, 78, 82, 87, 93, 98, 104, 110, 117, 123, 131, 139, 147, 156, 165, 175, 185, 196, 208, 220, 233, 247, 262, 277, 294, 311, 330, 349, 370, 392, 415, 440, 466, 494, 523, 554, 587, 622, 659, 698, 740, 784, 831, 880, 932, 988, 1047, 1109, 1175, 1245, 1319, 1397, 1480, 1568, 1661, 1760, 1865, 1976, 2093, 2217, 2349, 2489, 2637, 2794, 2960, 3136, 3322, 3520, 3729, 3951, 4186, 4435, 4699, 4978};
char* aryNotes[] = {"REST", "B0", "C1", "CS1", "D1", "DS1", "E1", "F1", "FS1", "G1", "GS1", "A1", "AS1", "B1", "C2", "CS2", "D2", "DS2", "E2", "F2", "FS2", "G2", "GS2", "A2", "AS2", "B2", "C3", "CS3", "D3", "DS3", "E3", "F3", "FS3", "G3", "GS3", "A3", "AS3", "B3", "C4", "CS4", "D4", "DS4", "E4", "F4", "FS4", "G4", "GS4", "A4", "AS4", "B4", "C5", "CS5", "D5", "DS5", "E5", "F5", "FS5", "G5", "GS5", "A5", "AS5", "B5", "C6", "CS6", "D6", "DS6", "E6", "F6", "FS6", "G6", "GS6", "A6", "AS6", "B6", "C7", "CS7", "D7", "DS7", "E7", "F7", "FS7", "G7", "GS7", "A7", "AS7", "B7", "C8", "CS8", "D8", "DS8"};
int aryDuration[] = {1, 2, 3, 4, 8, 16, 32, 64}; // note durations as in fractions of a whole beat, so 1 whole beat, half a beat, a third of a beat, a quater of a beat.....and so on
int intNoteCount = 89;
int intDurCount = 7;

long lngMillisInMins = 60000; // miliseconds in a miniute
int intBPM;
int intOneBeat;

//C4 = 39, = 262

//165="E3", 175="F3", 185="FS3", 196="G3", 208="GS3", 220="A3", 233="AS3", 247="B3", 262="C4", 277="CS4", 294="D4", 311="DS4", 330="E4", 349="F4", 370="FS4", 392="G4", 415="GS4", 440="A4", 466="AS4", 494="B4", 523="C5", 554="CS5", 587="D5"
//D D E D G F#, D D E D A G, D D ' D'B G F# E, C' C' B G A G 


// Happy Birthday
/*
char* aryDemoNames[] = {"D4", "D4", "E4", "D4", "G4", "FS4", "REST", "D4", "D4", "E4", "D4", "A4", "G4", "REST", "D4", "D4", "D5", "REST", "B3", "REST", "G3", "REST", "FS3", "E3", "REST", "C4", "C4", "B4", "REST", "G4", "REST", "A4", "REST", "G4"};
int aryDemoNotes[] = {294, 294, 330, 294, 392, 370, 0, 294, 294, 330, 294, 440, 392, 0, 294, 294, 587, 0, 247, 0, 196, 0, 185, 165, 0, 262, 262, 494, 0, 392, 0, 440, 0, 392};
int aryDemoLength[] = {2, 2, 1, 1, 1, 1, 1, 2, 2, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 1};
int intDemoCount=34;
int intDemoBPM=100;
long lngDemoOneBeat = (60000/intDemoBPM);
*/

//The Sorcerer's Apprentice - This one plays more fluidly

char* aryDemoNames[] = {"D4", "REST", "A4", "REST", "A3", "B3", "C3",
                        "D4", "REST", "A4", "REST", "A3", "B3", "C3",
                        "D4", "REST", "F4", "D4", "REST", "F4", "E4", "D4", "CS4",
                        "D4", "REST", "F4", "D4", "REST", "F4", "E4", "D4", "CS4",
                        "D4", "REST", "F4", "D4", "F4", "E4", "D4", "E4", "F4",
                        "D4", "REST", "A4", "REST", "A3", "B3", "C3",
                        "D4", "REST", "A4", "REST", "A3", "B3", "C3",
                        "D4", "REST", "F4", "D4", "REST", "F4", "E4", "D4", "CS4",
                        "D4", "REST", "F4", "D4", "REST", "F4", "E4", "D4", "CS4",
                        "D4", "REST", "F4", "D4", "F4", "E4", "D4", "E4", "F4"};
int aryDemoNotes[] =   {294, 0, 440, 0, 220, 247, 262,
                        294, 0, 440, 0, 220, 247, 262,
                        294, 0, 349, 294, 0, 349, 330, 294, 277,
                        294, 0, 349, 294, 0, 349, 330, 294, 277,
                        294, 0, 349, 294, 349, 330, 294, 330, 349,
                        294, 0, 440, 0, 220, 247, 262,
                        294, 0, 440, 0, 220, 247, 262,
                        294, 0, 349, 294, 0, 349, 330, 294, 277,
                        294, 0, 349, 294, 0, 349, 330, 294, 277,
                        294, 0, 349, 294, 349, 330, 294, 330, 349};
int aryDemoLength[] =  {2, 1, 2, 1, 2, 2, 2,
                        2, 1, 2, 1, 2, 2, 2,
                        2, 2, 2, 2, 2, 2, 2, 2, 2,
                        2, 2, 2, 2, 2, 2, 2, 2, 2,
                        2, 2, 2, 2, 2, 2, 2, 2, 2,
                        2, 1, 2, 1, 2, 2, 2,
                        2, 1, 2, 1, 2, 2, 2,
                        2, 2, 2, 2, 2, 2, 2, 2, 2,
                        2, 2, 2, 2, 2, 2, 2, 2, 2,
                        2, 2, 2, 2, 2, 2, 2, 2, 2};
int intDemoCount=82;
int intDemoBPM=120;
long lngDemoOneBeat = (60000/intDemoBPM);                 


//The Sorcerer's Apprentice - This one is more accurate to the original
/*
char* aryDemoNames[] = {"D4", "A4", "A3", "B3", "C3",
                        "D4", "A4", "A3", "B3", "C3",
                        "D4", "F4", "D4", "F4", "E4", "D4", "CS4",
                        "D4", "F4", "D4", "F4", "E4", "D4", "CS4",
                        "D4", "F4", "D4", "F4", "E4", "D4", "E4", "F4"};
int aryDemoNotes[] =   {294, 440, 220, 247, 262,
                        294, 440, 220, 247, 262,
                        294, 349, 294, 349, 330, 294, 277,
                        294, 349, 294, 349, 330, 294, 277,
                        294, 349, 294, 349, 330, 294, 330, 349};
int aryDemoLength[] =  {1, 1, 3, 3, 3,
                        1, 1, 3, 3, 3,
                        2, 3, 2, 3, 3, 3, 3,
                        2, 3, 2, 3, 3, 3, 3,
                        2, 3, 3, 3, 3, 3, 3, 3};
int intDemoCount=32;
int intDemoBPM=120;
long lngDemoOneBeat = (60000/intDemoBPM);
*/

int intButtonState = 0;  // variable for reading the pushbutton status, set 0 as default

int aryKey[100] = {}; // create an array to store the notes of the tune
int aryLength[100] = {}; // create an array to store the length of the notes in the tune
int intKeyIndex = 0;

char* aryPreMenu[] = {"Start", "Demo"};
int intPreMenu = 1;
int intMenuStage = 0;
int intSelectIndex = 0;
int intSubMenu = 3;
char* arySubMenu[] = {"Next", "Change", "Play", "Delete"};

// Global Settings:
LiquidCrystal lcd(13, 12, 5, 4, 3, 2);  // set the pin numbers for the 4bit LCD bus stuff


void setup() // The pre loop sub, one time set-ups
{  
  pinMode(intPinButM, INPUT); // Set up pin modes for digital pins,
  digitalWrite(intPinButM, HIGH); // and set their internal pull-up resistors.
  pinMode(intPinButA, INPUT); // Buttons A and B are "push to make" buttons so the pull-up resistors will be back to front,
  digitalWrite(intPinButA, HIGH); // pushing them should create the circut to ground, dropping the voltage
  pinMode(intPinButB, INPUT);
  digitalWrite(intPinButB, HIGH);

  lcd.begin(16,2);  // set up the screen, we have a screen that is 16 cols by 2 rows
}


void loop() // The main processor loop
{
  delay(200);
  switch(intMenuStage)
  {
      case 0: // show the pre menu
        lcd.clear();
        lcd.setCursor(0,0);
        lcd.print(aryPreMenu[intSelectIndex]);
      break;
      
      case 1: // process the result
        if(intSelectIndex==0) // the user selected start so let them start
        {
          intSelectIndex = 60; // set this to 60 as a starting point for the users BPM setting which is next
          intMenuStage++;
        }
        else if(intSelectIndex==1) // the user selected a demo so play the demo
        {
          for(int i = 0; i < intDemoCount; i++)
          {
            lcd.clear();
            lcd.setCursor(0,0);
            lcd.print(aryDemoNotes[i]);
            lcd.setCursor(0,1);
            lcd.print(aryDemoNames[i]);
            tone(intPinSpk, aryDemoNotes[i], (lngDemoOneBeat/aryDemoLength[i]));
            delay((lngDemoOneBeat/aryDemoLength[i]));
          }
          delay(500);
          intMenuStage=0;
        }
      break;
      
      case 2: // set the BPM value for the tune
        lcd.clear();
        lcd.setCursor(0,0);
        lcd.print("Set BMP: ");
        lcd.print(intSelectIndex);
      break;
      
      case 3: // store and display the bpm selection and then move on to the note selection
        lcd.clear();
        lcd.setCursor(0,0);
        lcd.print("BMP set at ");
        intBPM = intSelectIndex;
        lcd.print(intBPM);
        intOneBeat = (lngMillisInMins / intBPM);
        intMenuStage=4;
        intSelectIndex=38; // preselect C4 as the starting note
        delay(1000);
      break;
      
      case 4: // display the note selection screen, and any chosen notes so far
        lcd.clear();
        if(intKeyIndex>0)
        { // make sure some notes have actually been stored before we try and display the stored notes
          lcd.setCursor(0,0);
          if(intKeyIndex>3) {
            for(int i = (intKeyIndex-1); i >= (intKeyIndex-4); i--)
            {
             lcd.print(aryNotes[aryKey[i]]);
             lcd.print(" ");
            }
          } else {
            for(int i = 0; i < intKeyIndex; i++)
            {
             lcd.print(aryNotes[aryKey[i]]);
             lcd.print(" ");
            }
          }
        }
        lcd.setCursor(0,1);
        lcd.print(aryNotes[intSelectIndex]);
      break; 
      
      case 5: // store the selected note
        lcd.clear();
        aryKey[intKeyIndex] = intSelectIndex;
        lcd.setCursor(0,0);
        lcd.print("Stored: ");
        lcd.print(aryNotes[aryKey[intKeyIndex]]);
        intSelectIndex=0;
        intMenuStage=6;
        delay(1000);
      break;
      
      case 6: // display the note duration options
        lcd.clear();
        lcd.setCursor(0,0);
        lcd.print("Duration: ");
        //lcd.setCursor(0,1);
        lcd.print(aryDuration[intSelectIndex]);
        lcd.setCursor(0,1);
        lcd.print((intOneBeat/aryDuration[intSelectIndex]));
        tone(intPinSpk, aryTones[aryKey[intKeyIndex]], (intOneBeat/aryDuration[intSelectIndex]));
        delay((intOneBeat/aryDuration[intSelectIndex]));
      break;
      
      case 7: // store the note duration
        aryLength[intKeyIndex] = (intOneBeat/aryDuration[intSelectIndex]);
        lcd.clear();
        lcd.setCursor(0,0);
        lcd.print("Stored: ");
        lcd.print(aryLength[intKeyIndex]);
        intMenuStage=8;
        intSelectIndex=0;
        delay(1000);
      break;
      
      case 8: // display the sub menu
        lcd.clear();
        lcd.setCursor(0,0);
        lcd.print(arySubMenu[intSelectIndex]);
      break;
      
      case 9: // process the chosen sub menu option
        lcd.clear();
        lcd.setCursor(0,0);
        if(intSelectIndex==0) // the user selected to go onto the next note
        {
          delay(400);
          intKeyIndex++;
          intSelectIndex=38; // preselect C4 as the starting note
          intMenuStage=4;
        }
        else if(intSelectIndex==1) // the user wants to change the note just entered
        {
          intSelectIndex=38; // preselect C4 as the starting note
          intMenuStage=4;
        }
        else if(intSelectIndex==2) // the user wants to play the tune so far
        {
          intMenuStage=10;
        }
        else if(intSelectIndex==3) // the user wants to delete the last note
        {
          intKeyIndex--; // Go back one key index
          //intSelectIndex=38; // preselect C4 as the starting note
          //intMenuStage=4; // Back to the note selection screen
          intSelectIndex=0;
          intMenuStage=8;
          lcd.clear();
          lcd.setCursor(0,0);
          lcd.print("Deleted");
          delay(800);
          lcd.clear();
        }
      break;
      
      case 10: // play the melody so far
        for(int i = 0; i <= intKeyIndex; i++)
        {
          lcd.clear();
          lcd.setCursor(0,0);
          lcd.print(aryLength[i]);
          lcd.setCursor(0,1);
          lcd.print(aryNotes[aryKey[i]]);
          tone(intPinSpk, aryTones[aryKey[i]], aryLength[i]);
          delay(aryLength[i]); 
        }
        delay(500);
        intMenuStage=8;
      break;
  }

  if(digitalRead(intPinButA)==LOW)
  {
    if(intSelectIndex>0)
    {
      intSelectIndex--;
      if(intMenuStage==4) // we are choosing the note
      {
        tone(intPinSpk, aryTones[intSelectIndex], (intOneBeat/8)); // play each note as we cycle through them
        delay((intOneBeat/8));
      }
    }
  }
  
  if(digitalRead(intPinButB)==LOW)
  {
    if(intMenuStage==0) // if we are at the pre menu
    {
      if(intSelectIndex<intPreMenu)
      {
        intSelectIndex++;
      }
    }
    else if(intMenuStage==2) // else if we are choosing the song BPM
    {
      intSelectIndex++;
    }
    else if(intMenuStage==4) // else if we are choosing the note
    {
      if(intSelectIndex<intNoteCount) // then make sure we dont exceed the number of notes available
      {
        intSelectIndex++;
        tone(intPinSpk, aryTones[intSelectIndex], (intOneBeat/8)); // play each note as we cycle through them
      }
    }
    else if(intMenuStage==6) // else if we are choosing the note duration
    { 
      if(intSelectIndex<intDurCount) // then make sure we dont exceed the number of note durations available
      {
        intSelectIndex++;
      }
    }
    else if(intMenuStage==8) // else if we are looking through the sub menu
    {
      if(intSelectIndex<intSubMenu)
      {
        intSelectIndex++;
      }
    }
  }
  
  if(digitalRead(intPinButM)==HIGH)
  {
    intMenuStage++; 
  }

}
